﻿"use strict";

var WingtipToys = window.WingtipToys || {};
WingtipToys.Jsom = WingtipToys.Jsom || {};

WingtipToys.Jsom.Fields = function () {

    var deferreds = new Array(),

        addField = function (listTitle, fieldDisplayName, fieldType) {
            deferreds[deferreds.length] = $.Deferred();
            var xmlDef = "<Field DisplayName='" + fieldDisplayName +
                         "' Type='" + fieldType + "'/>";
            var ctx = new SP.ClientContext.get_current();
            this.field = ctx.get_web().get_lists().getByTitle(listTitle).get_fields().addFieldAsXml(
                xmlDef, false, SP.AddFieldOptions.addToNoContentType);
            this.field.update();
            ctx.load(this.field);
            ctx.executeQueryAsync(
                Function.createDelegate(this,
                    function () { deferreds[deferreds.length - 1].resolve(this.field); }),
                Function.createDelegate(this,
                    function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

            return deferreds[deferreds.length - 1].promise();

        },

        addSiteColumn = function (fieldDisplayName, fieldType, local) {
            deferreds[deferreds.length] = $.Deferred();
            var xmlDef = "<Field DisplayName='" + fieldDisplayName +
                            "' Type='" + fieldType + "'/>";
            var ctx = new SP.ClientContext.get_current();
            if (local === true) {
                this.field = ctx.get_web().get_fields().addFieldAsXml(
                xmlDef, false, SP.AddFieldOptions.addToNoContentType);
            }
            else {
                this.field = ctx.get_site().get_rootWeb().get_fields().addFieldAsXml(
                xmlDef, false, SP.AddFieldOptions.addToNoContentType);
            }
            ctx.load(this.field);
            this.field.set_group("Wingtip Toys");
            this.field.updateAndPushChanges(false);
            ctx.executeQueryAsync(
                Function.createDelegate(this,
                    function () { deferreds[deferreds.length - 1].resolve(this.field); }),
                Function.createDelegate(this,
                    function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

            return deferreds[deferreds.length - 1].promise();

        },

        addSiteColumnChoice = function (internalFieldName, newChoice, local) {
            deferreds[deferreds.length] = $.Deferred();
            var ctx = new SP.ClientContext.get_current();
            var column;
            if (local === true) {
                column = ctx.get_web().get_fields().getByInternalNameOrTitle(internalFieldName);
            }
            else {
                column = ctx.get_site().get_rootWeb().get_fields().getByInternalNameOrTitle(internalFieldName);
            }
            ctx.load(column);
            this.choiceColumn = ctx.castTo(column, SP.FieldChoice);
            ctx.load(this.choiceColumn);
            this.choiceColumn.set_choices(newChoice);
            this.choiceColumn.updateAndPushChanges(true);
            ctx.executeQueryAsync(
                Function.createDelegate(this,
                    function () { deferreds[deferreds.length - 1].resolve(this.choiceColumn); }),
                Function.createDelegate(this,
                    function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

            return deferreds[deferreds.length - 1].promise();

        },

        addLookup = function (listTitle, fieldDisplayName, lookupListId) {
            deferreds[deferreds.length] = $.Deferred();
            var xmlDef = "<Field DisplayName='" + fieldDisplayName + "' Type='Lookup'/>";
            var ctx = new SP.ClientContext.get_current();
            var field = ctx.get_web().get_lists().getByTitle(listTitle).get_fields().addFieldAsXml(
                         xmlDef, false, SP.AddFieldOptions.addToNoContentType);
            this.lookupField = ctx.castTo(field, SP.FieldLookup);
            this.lookupField.set_lookupList(lookupListId);
            this.lookupField.set_lookupField("Title");
            this.lookupField.update();
            ctx.load(this.lookupField);

            ctx.executeQueryAsync(
                Function.createDelegate(this,
                    function () { deferreds[deferreds.length - 1].resolve(this.lookupField); }),
                Function.createDelegate(this,
                    function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

            return deferreds[deferreds.length - 1].promise();

        },

        getField = function (listTitle, internalFieldName) {
            deferreds[deferreds.length] = $.Deferred();
            var ctx = new SP.ClientContext.get_current();
            this.field = ctx.get_web().get_lists().getByTitle(listTitle).get_fields().getByInternalNameOrTitle(internalFieldName);
            ctx.load(this.field);
            ctx.executeQueryAsync(
                Function.createDelegate(this,
                    function () { deferreds[deferreds.length - 1].resolve(this.field); }),
                Function.createDelegate(this,
                    function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

            return deferreds[deferreds.length - 1].promise();

        },

        getSiteColumn = function (internalFieldName) {
            deferreds[deferreds.length] = $.Deferred();
            var ctx = new SP.ClientContext.get_current();
            this.column = ctx.get_web().get_availableFields().getByInternalNameOrTitle(internalFieldName);
            ctx.load(this.column);
            ctx.executeQueryAsync(
                Function.createDelegate(this,
                    function () { deferreds[deferreds.length - 1].resolve(this.column); }),
                Function.createDelegate(this,
                    function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

            return deferreds[deferreds.length - 1].promise();

        },

       setDisplayName = function (listTitle, internalFieldName, displayFieldName) {
            deferreds[deferreds.length] = $.Deferred();
            var ctx = new SP.ClientContext.get_current();
            this.field = ctx.get_web().get_lists().getByTitle(listTitle).get_fields().getByInternalNameOrTitle(internalFieldName);
            ctx.load(this.field);
            this.field.set_title(displayFieldName);
            this.field.update();
            ctx.executeQueryAsync(
                Function.createDelegate(this,
                    function () { deferreds[deferreds.length - 1].resolve(this.field); }),
                Function.createDelegate(this,
                    function (sender, args) { deferreds[deferreds.length - 1].reject(sender, args); }));

            return deferreds[deferreds.length - 1].promise();

       };

    return {
        add_field: addField,
        add_siteColumn:addSiteColumn,
        add_siteColumnChoice:addSiteColumnChoice,
        get_field: getField,
        get_siteColumn: getSiteColumn,
        set_displayName: setDisplayName
    };
}();