﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Microsoft.SharePoint.Client;
using Microsoft.BusinessData;
using Microsoft.BusinessData.Infrastructure;
using Microsoft.BusinessData.Runtime;
using Microsoft.BusinessData.MetadataModel;
using Microsoft.BusinessData.MetadataModel.Collections;

namespace ExecuteFinder
{
    class Program
    {
        static void Main(string[] args)
        {
            try
            {

                if (args.Count() != 5)
                    throw new Exception("Useage: ExecuteFinder SiteCollectionUrl LobSystemInstance EntityName EntityNamespace FinderMethodInstance");

                string siteCollectionUrl = args[0];
                string lobSystemInstance = args[1];
                string entityName = args[2];
                string entityNamespace = args[3];
                string finderMethodInstance = args[4];

                ClientContext ctx = new ClientContext(siteCollectionUrl);

                //Get entity
                Entity ect = ctx.Web.GetAppBdcCatalog().GetEntity(entityNamespace, entityName);
                ctx.Load(ect);

                //Get LobSystem 
                LobSystem lob = ect.GetLobSystem();
                ctx.Load(lob);

                //Get LobSystemInstances
                LobSystemInstanceCollection lobis = lob.GetLobSystemInstances();
                ctx.Load(lobis);
                ctx.ExecuteQuery();

                //Get LobSystemInstance
                LobSystemInstance lobi = lobis.Where(l => l.Name == lobSystemInstance).First();
                ctx.Load(lobi);

                MethodExecutionResult results  = ect.Execute(finderMethodInstance, lobi, null);
                ctx.Load(results);
                ctx.ExecuteQuery();

                foreach(var i in results.ReturnParameterCollection)
                {
                    Dictionary<string, object> fields = i.FieldValues;

                    foreach (KeyValuePair<string,object> field in fields)
                    {
                        Console.WriteLine(field.Value);
                    }
                }
            }
            catch (Exception x)
            {
                Console.WriteLine(x.Message);
            }

            Console.Read();

        }
    }
}
